## e200806e56095091ff22a73c4c8ec294176527e2

=== introspection/CMakeLists.txt ===
# Copyright (c) Facebook, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

include_directories(${CMAKE_SOURCE_DIR}/src/cc)
include_directories(${CMAKE_SOURCE_DIR}/src/cc/api)
include_directories(${CMAKE_SOURCE_DIR}/src/cc/libbpf/include/uapi)

option(INSTALL_INTROSPECTION "Install BPF introspection tools" ON)

add_executable(bps bps.c)
target_link_libraries(bps bpf-static)

install (TARGETS bps DESTINATION share/bcc/introspection)

=== snapcraft/Makefile ===
#
# Copyright (C) 2016 Canonical
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

#
# Simple makefile to mangle version info in the yaml file
#
VERSION=$(shell git tag | sort -V | tail -1 | cut -c2-)
COMMITS=$(shell git log --oneline | wc -l)
SHA=$(shell git log -1 --oneline | cut -d' ' -f1)
DATE=$(shell date +'%Y%m%d')
V=$(VERSION)-$(DATE)-$(COMMITS)-$(SHA)

all: set_version
	snapcraft

set_version:
	cat snapcraft.yaml | sed 's/^version: .*/version: $(V)/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

install:
	#
	# Install latest snap
	#
	sudo snap install --devmode bcc_*.snap

	#
	# Connect up interfaces
	#
	sudo snap connect bcc:mount-observe
	sudo snap connect bcc:system-observe
	sudo snap connect bcc:system-trace

remove:
	sudo snap remove bcc

clean:
	snapcraft clean
	rm -rf setup *.snap snapcraft

=== examples/cpp/CMakeLists.txt ===
# Copyright (c) Facebook, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

include_directories(${CMAKE_SOURCE_DIR}/src/cc)
include_directories(${CMAKE_SOURCE_DIR}/src/cc/api)
include_directories(${CMAKE_SOURCE_DIR}/src/cc/libbpf/include/uapi)

option(INSTALL_CPP_EXAMPLES "Install C++ examples. Those binaries are statically linked and can take plenty of disk space" OFF)

add_executable(HelloWorld HelloWorld.cc)
target_link_libraries(HelloWorld bcc-static)

add_executable(CPUDistribution CPUDistribution.cc)
target_link_libraries(CPUDistribution bcc-static)

add_executable(RecordMySQLQuery RecordMySQLQuery.cc)
target_link_libraries(RecordMySQLQuery bcc-static)

add_executable(TCPSendStack TCPSendStack.cc)
target_link_libraries(TCPSendStack bcc-static)

add_executable(RandomRead RandomRead.cc)
target_link_libraries(RandomRead bcc-static)

add_executable(LLCStat LLCStat.cc)
target_link_libraries(LLCStat bcc-static)

add_executable(FollyRequestContextSwitch FollyRequestContextSwitch.cc)
target_link_libraries(FollyRequestContextSwitch bcc-static)

add_executable(UseExternalMap UseExternalMap.cc)
target_link_libraries(UseExternalMap bcc-static)

add_executable(CGroupTest CGroupTest.cc)
target_link_libraries(CGroupTest bcc-static)

if(INSTALL_CPP_EXAMPLES)
  install (TARGETS HelloWorld DESTINATION share/bcc/examples/cpp)
  install (TARGETS CPUDistribution DESTINATION share/bcc/examples/cpp)
  install (TARGETS RecordMySQLQuery DESTINATION share/bcc/examples/cpp)
  install (TARGETS TCPSendStack DESTINATION share/bcc/examples/cpp)
  install (TARGETS RandomRead DESTINATION share/bcc/examples/cpp)
  install (TARGETS LLCStat DESTINATION share/bcc/examples/cpp)
  install (TARGETS FollyRequestContextSwitch DESTINATION share/bcc/examples/cpp)
  install (TARGETS UseExternalMap DESTINATION share/bcc/examples/cpp)
  install (TARGETS CGroupTest DESTINATION share/bcc/examples/cpp)
endif(INSTALL_CPP_EXAMPLES)

add_subdirectory(pyperf)

=== debian/control ===
Source: bcc
Maintainer: Brenden Blanco <bblanco@plumgrid.com>
Section: misc
Priority: optional
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9), cmake,
    libllvm3.7 [!arm64] | libllvm3.8 [!arm64] | libllvm6.0,
    llvm-3.7-dev [!arm64] | llvm-3.8-dev [!arm64] | llvm-6.0-dev,
    libclang-3.7-dev [!arm64] | libclang-3.8-dev [!arm64] | libclang-6.0-dev,
    clang-format | clang-format-3.7 [!arm64] | clang-format-3.8 [!arm64] | clang-format-6.0,
    libelf-dev, bison, flex, libfl-dev, libedit-dev, zlib1g-dev, git,
    python (>= 2.7), python-netaddr, python-pyroute2, luajit,
    libluajit-5.1-dev, arping, inetutils-ping | iputils-ping, iperf, netperf,
    ethtool, devscripts, python3, dh-python
Homepage: https://github.com/iovisor/bcc

Package: libbcc
Architecture: all
Provides: libbpfcc, libbpfcc-dev
Conflicts: libbpfcc, libbpfcc-dev
Depends: libc6, libstdc++6, libelf1
Description: Shared Library for BPF Compiler Collection (BCC)
 Shared Library for BPF Compiler Collection to control BPF programs
 from userspace.

Package: libbcc-examples
Architecture: any
Depends: libbcc (= ${binary:Version})
Description: Examples for BPF Compiler Collection (BCC)

Package: python-bcc
Architecture: all
Provides: python-bpfcc
Conflicts: python-bpfcc
Depends: libbcc (= ${binary:Version}), python, binutils
Description: Python wrappers for BPF Compiler Collection (BCC)

Package: python3-bcc
Architecture: all
Provides: python3-bpfcc
Conflicts: python3-bpfcc
Depends: libbcc (= ${binary:Version}), python3, binutils
Description: Python3 wrappers for BPF Compiler Collection (BCC)

Package: bcc-tools
Architecture: all
Provides: bpfcc-tools
Conflicts: bpfcc-tools
Depends: python-bcc (= ${binary:Version})
Description: Command line tools for BPF Compiler Collection (BCC)

Package: bcc-lua
Architecture: all
Provides: bpfcc-lua
Conflicts: bpfcc-lua
Depends: libbcc (= ${binary:Version})
Description: Standalone tool to run BCC tracers written in Lua
